<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
    <!-- Generated by javadoc -->
    <title>AbstractEscherOptRecord (POI API Documentation)</title>
    <link rel="stylesheet" type="text/css" href="../../../../stylesheet.css" title="Style">
    <script type="text/javascript" src="../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="AbstractEscherOptRecord (POI API Documentation)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":10,"i9":10,"i10":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";

</script>
<noscript>
    <div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.top.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/AbstractEscherOptRecord.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../index-all.html">Index</a></li>
        <li><a href="../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li>Prev&nbsp;Class</li>
        <li><a href="../../../../org/apache/poi/ddf/DefaultEscherRecordFactory.html"
               title="class in org.apache.poi.ddf"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../index.html?org/apache/poi/ddf/AbstractEscherOptRecord.html" target="_top">Frames</a>
        </li>
        <li><a href="AbstractEscherOptRecord.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_top">
        <li><a href="../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.top">
        <!--   -->
    </a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
    <div class="subTitle">org.apache.poi.ddf</div>
    <h2 title="Class AbstractEscherOptRecord" class="title">Class AbstractEscherOptRecord</h2>
</div>
<div class="contentContainer">
    <ul class="inheritance">
        <li>java.lang.Object</li>
        <li>
            <ul class="inheritance">
                <li><a href="../../../../org/apache/poi/ddf/EscherRecord.html" title="class in org.apache.poi.ddf">org.apache.poi.ddf.EscherRecord</a>
                </li>
                <li>
                    <ul class="inheritance">
                        <li>org.apache.poi.ddf.AbstractEscherOptRecord</li>
                    </ul>
                </li>
            </ul>
        </li>
    </ul>
    <div class="description">
        <ul class="blockList">
            <li class="blockList">
                <dl>
                    <dt>All Implemented Interfaces:</dt>
                    <dd>java.lang.Cloneable</dd>
                </dl>
                <dl>
                    <dt>Direct Known Subclasses:</dt>
                    <dd><a href="../../../../org/apache/poi/ddf/EscherOptRecord.html"
                           title="class in org.apache.poi.ddf">EscherOptRecord</a>, <a
                            href="../../../../org/apache/poi/ddf/EscherTertiaryOptRecord.html"
                            title="class in org.apache.poi.ddf">EscherTertiaryOptRecord</a></dd>
                </dl>
                <hr>
                <br>
                <pre>public abstract class <span class="typeNameLabel">AbstractEscherOptRecord</span>
extends <a href="../../../../org/apache/poi/ddf/EscherRecord.html" title="class in org.apache.poi.ddf">EscherRecord</a></pre>
                <div class="block">Common abstract class for <a
                        href="../../../../org/apache/poi/ddf/EscherOptRecord.html"
                        title="class in org.apache.poi.ddf"><code>EscherOptRecord</code></a> and
                    <a href="../../../../org/apache/poi/ddf/EscherTertiaryOptRecord.html"
                       title="class in org.apache.poi.ddf"><code>EscherTertiaryOptRecord</code></a></div>
            </li>
        </ul>
    </div>
    <div class="summary">
        <ul class="blockList">
            <li class="blockList">
                <!-- ======== CONSTRUCTOR SUMMARY ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="constructor.summary">
                        <!--   -->
                    </a>
                        <h3>Constructor Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Constructor Summary table, listing constructors, and an explanation">
                            <caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
                            <tr>
                                <th class="colOne" scope="col">Constructor and Description</th>
                            </tr>
                            <tr class="altColor">
                                <td class="colOne"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/AbstractEscherOptRecord.html#AbstractEscherOptRecord--">AbstractEscherOptRecord</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                        </table>
                    </li>
                </ul>
                <!-- ========== METHOD SUMMARY =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.summary">
                        <!--   -->
                    </a>
                        <h3>Method Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Method Summary table, listing methods, and an explanation">
                            <caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span
                                    id="t2" class="tableTab"><span><a
                                    href="javascript:show(2);">Instance Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a
                                    href="javascript:show(8);">Concrete Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier and Type</th>
                                <th class="colLast" scope="col">Method and Description</th>
                            </tr>
                            <tr id="i0" class="altColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/AbstractEscherOptRecord.html#addEscherProperty-org.apache.poi.ddf.EscherProperty-">addEscherProperty</a></span>(<a
                                        href="../../../../org/apache/poi/ddf/EscherProperty.html"
                                        title="class in org.apache.poi.ddf">EscherProperty</a>&nbsp;prop)</code>
                                    <div class="block">Add a property to this record.</div>
                                </td>
                            </tr>
                            <tr id="i1" class="rowColor">
                                <td class="colFirst"><code>int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/AbstractEscherOptRecord.html#fillFields-byte:A-int-org.apache.poi.ddf.EscherRecordFactory-">fillFields</a></span>(byte[]&nbsp;data,
                                    int&nbsp;offset,
                                    <a href="../../../../org/apache/poi/ddf/EscherRecordFactory.html"
                                       title="interface in org.apache.poi.ddf">EscherRecordFactory</a>&nbsp;recordFactory)</code>
                                    <div class="block">The contract of this method is to deserialize an escher record
                                        including
                                        it's children.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i2" class="altColor">
                                <td class="colFirst"><code>protected java.lang.Object[][]</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/AbstractEscherOptRecord.html#getAttributeMap--">getAttributeMap</a></span>()</code>
                                    <div class="block">For the purpose of providing toString() and toXml() a subclass
                                        can either override those methods
                                        or provide a Object[][] array in the form { { "Attribute Name (Header)", value,
                                        "optional attribute", value }, ...
                                    </div>
                                </td>
                            </tr>
                            <tr id="i3" class="rowColor">
                                <td class="colFirst"><code>java.util.List&lt;<a
                                        href="../../../../org/apache/poi/ddf/EscherProperty.html"
                                        title="class in org.apache.poi.ddf">EscherProperty</a>&gt;</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/AbstractEscherOptRecord.html#getEscherProperties--">getEscherProperties</a></span>()</code>
                                    <div class="block">The list of properties stored by this record.</div>
                                </td>
                            </tr>
                            <tr id="i4" class="altColor">
                                <td class="colFirst"><code><a href="../../../../org/apache/poi/ddf/EscherProperty.html"
                                                              title="class in org.apache.poi.ddf">EscherProperty</a></code>
                                </td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/AbstractEscherOptRecord.html#getEscherProperty-int-">getEscherProperty</a></span>(int&nbsp;index)</code>
                                    <div class="block">The list of properties stored by this record.</div>
                                </td>
                            </tr>
                            <tr id="i5" class="rowColor">
                                <td class="colFirst"><code>int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/AbstractEscherOptRecord.html#getRecordSize--">getRecordSize</a></span>()</code>
                                    <div class="block">Subclasses should effeciently return the number of bytes required
                                        to
                                        serialize the record.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i6" class="altColor">
                                <td class="colFirst"><code>&lt;T extends <a
                                        href="../../../../org/apache/poi/ddf/EscherProperty.html"
                                        title="class in org.apache.poi.ddf">EscherProperty</a>&gt;<br>T</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/AbstractEscherOptRecord.html#lookup-int-">lookup</a></span>(int&nbsp;propId)</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i7" class="rowColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/AbstractEscherOptRecord.html#removeEscherProperty-int-">removeEscherProperty</a></span>(int&nbsp;num)</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i8" class="altColor">
                                <td class="colFirst"><code>int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/AbstractEscherOptRecord.html#serialize-int-byte:A-org.apache.poi.ddf.EscherSerializationListener-">serialize</a></span>(int&nbsp;offset,
                                    byte[]&nbsp;data,
                                    <a href="../../../../org/apache/poi/ddf/EscherSerializationListener.html"
                                       title="interface in org.apache.poi.ddf">EscherSerializationListener</a>&nbsp;listener)</code>
                                    <div class="block">Serializes the record to an existing byte array.</div>
                                </td>
                            </tr>
                            <tr id="i9" class="rowColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/AbstractEscherOptRecord.html#setEscherProperty-org.apache.poi.ddf.EscherProperty-">setEscherProperty</a></span>(<a
                                        href="../../../../org/apache/poi/ddf/EscherProperty.html"
                                        title="class in org.apache.poi.ddf">EscherProperty</a>&nbsp;value)</code>
                                    <div class="block">Set an escher property.</div>
                                </td>
                            </tr>
                            <tr id="i10" class="altColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/AbstractEscherOptRecord.html#sortProperties--">sortProperties</a></span>()</code>
                                    <div class="block">Records should be sorted by property number before being
                                        stored.
                                    </div>
                                </td>
                            </tr>
                        </table>
                        <ul class="blockList">
                            <li class="blockList"><a
                                    name="methods.inherited.from.class.org.apache.poi.ddf.EscherRecord">
                                <!--   -->
                            </a>
                                <h3>Methods inherited from class&nbsp;org.apache.poi.ddf.<a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html"
                                        title="class in org.apache.poi.ddf">EscherRecord</a></h3>
                                <code><a href="../../../../org/apache/poi/ddf/EscherRecord.html#clone--">clone</a>, <a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html#display-java.io.PrintWriter-int-">display</a>,
                                    <a href="../../../../org/apache/poi/ddf/EscherRecord.html#fillFields-byte:A-org.apache.poi.ddf.EscherRecordFactory-">fillFields</a>,
                                    <a href="../../../../org/apache/poi/ddf/EscherRecord.html#getChild-int-">getChild</a>,
                                    <a href="../../../../org/apache/poi/ddf/EscherRecord.html#getChildRecords--">getChildRecords</a>,
                                    <a href="../../../../org/apache/poi/ddf/EscherRecord.html#getInstance--">getInstance</a>,
                                    <a href="../../../../org/apache/poi/ddf/EscherRecord.html#getOptions--">getOptions</a>,
                                    <a href="../../../../org/apache/poi/ddf/EscherRecord.html#getRecordId--">getRecordId</a>,
                                    <a href="../../../../org/apache/poi/ddf/EscherRecord.html#getRecordName--">getRecordName</a>,
                                    <a href="../../../../org/apache/poi/ddf/EscherRecord.html#getVersion--">getVersion</a>,
                                    <a href="../../../../org/apache/poi/ddf/EscherRecord.html#isContainerRecord--">isContainerRecord</a>,
                                    <a href="../../../../org/apache/poi/ddf/EscherRecord.html#readHeader-byte:A-int-">readHeader</a>,
                                    <a href="../../../../org/apache/poi/ddf/EscherRecord.html#readInstance-byte:A-int-">readInstance</a>,
                                    <a href="../../../../org/apache/poi/ddf/EscherRecord.html#serialize--">serialize</a>,
                                    <a href="../../../../org/apache/poi/ddf/EscherRecord.html#serialize-int-byte:A-">serialize</a>,
                                    <a href="../../../../org/apache/poi/ddf/EscherRecord.html#setChildRecords-java.util.List-">setChildRecords</a>,
                                    <a href="../../../../org/apache/poi/ddf/EscherRecord.html#setInstance-short-">setInstance</a>,
                                    <a href="../../../../org/apache/poi/ddf/EscherRecord.html#setOptions-short-">setOptions</a>,
                                    <a href="../../../../org/apache/poi/ddf/EscherRecord.html#setRecordId-short-">setRecordId</a>,
                                    <a href="../../../../org/apache/poi/ddf/EscherRecord.html#setVersion-short-">setVersion</a>,
                                    <a href="../../../../org/apache/poi/ddf/EscherRecord.html#toString--">toString</a>,
                                    <a href="../../../../org/apache/poi/ddf/EscherRecord.html#toXml--">toXml</a>, <a
                                            href="../../../../org/apache/poi/ddf/EscherRecord.html#toXml-java.lang.String-">toXml</a></code>
                            </li>
                        </ul>
                        <ul class="blockList">
                            <li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
                                <!--   -->
                            </a>
                                <h3>Methods inherited from class&nbsp;java.lang.Object</h3>
                                <code>equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait</code>
                            </li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
    <div class="details">
        <ul class="blockList">
            <li class="blockList">
                <!-- ========= CONSTRUCTOR DETAIL ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="constructor.detail">
                        <!--   -->
                    </a>
                        <h3>Constructor Detail</h3>
                        <a name="AbstractEscherOptRecord--">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>AbstractEscherOptRecord</h4>
                                <pre>public&nbsp;AbstractEscherOptRecord()</pre>
                            </li>
                        </ul>
                    </li>
                </ul>
                <!-- ============ METHOD DETAIL ========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.detail">
                        <!--   -->
                    </a>
                        <h3>Method Detail</h3>
                        <a name="addEscherProperty-org.apache.poi.ddf.EscherProperty-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>addEscherProperty</h4>
                                <pre>public&nbsp;void&nbsp;addEscherProperty(<a
                                        href="../../../../org/apache/poi/ddf/EscherProperty.html"
                                        title="class in org.apache.poi.ddf">EscherProperty</a>&nbsp;prop)</pre>
                                <div class="block">Add a property to this record.</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>prop</code> - the escher property to add</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="fillFields-byte:A-int-org.apache.poi.ddf.EscherRecordFactory-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>fillFields</h4>
                                <pre>public&nbsp;int&nbsp;fillFields(byte[]&nbsp;data,
                      int&nbsp;offset,
                      <a href="../../../../org/apache/poi/ddf/EscherRecordFactory.html"
                         title="interface in org.apache.poi.ddf">EscherRecordFactory</a>&nbsp;recordFactory)</pre>
                                <div class="block"><span
                                        class="descfrmTypeLabel">Description copied from class:&nbsp;<code><a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html#fillFields-byte:A-int-org.apache.poi.ddf.EscherRecordFactory-">EscherRecord</a></code></span>
                                </div>
                                <div class="block">The contract of this method is to deserialize an escher record
                                    including
                                    it's children.
                                </div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../org/apache/poi/ddf/EscherRecord.html#fillFields-byte:A-int-org.apache.poi.ddf.EscherRecordFactory-">fillFields</a></code>&nbsp;in
                                        class&nbsp;<code><a href="../../../../org/apache/poi/ddf/EscherRecord.html"
                                                            title="class in org.apache.poi.ddf">EscherRecord</a></code>
                                    </dd>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>data</code> - The byte array containing the serialized escher
                                        records.
                                    </dd>
                                    <dd><code>offset</code> - The offset into the byte array.</dd>
                                    <dd><code>recordFactory</code> - A factory for creating new escher records.</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>The number of bytes written.</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getEscherProperties--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getEscherProperties</h4>
                                <pre>public&nbsp;java.util.List&lt;<a
                                        href="../../../../org/apache/poi/ddf/EscherProperty.html"
                                        title="class in org.apache.poi.ddf">EscherProperty</a>&gt;&nbsp;getEscherProperties()</pre>
                                <div class="block">The list of properties stored by this record.</div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the list of properties</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getEscherProperty-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getEscherProperty</h4>
                                <pre>public&nbsp;<a href="../../../../org/apache/poi/ddf/EscherProperty.html"
                                                    title="class in org.apache.poi.ddf">EscherProperty</a>&nbsp;getEscherProperty(int&nbsp;index)</pre>
                                <div class="block">The list of properties stored by this record.</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>index</code> - the ordinal index of the property</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the escher property</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getRecordSize--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getRecordSize</h4>
                                <pre>public&nbsp;int&nbsp;getRecordSize()</pre>
                                <div class="block"><span
                                        class="descfrmTypeLabel">Description copied from class:&nbsp;<code><a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html#getRecordSize--">EscherRecord</a></code></span>
                                </div>
                                <div class="block">Subclasses should effeciently return the number of bytes required to
                                    serialize the record.
                                </div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../org/apache/poi/ddf/EscherRecord.html#getRecordSize--">getRecordSize</a></code>&nbsp;in
                                        class&nbsp;<code><a href="../../../../org/apache/poi/ddf/EscherRecord.html"
                                                            title="class in org.apache.poi.ddf">EscherRecord</a></code>
                                    </dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>number of bytes</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="lookup-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>lookup</h4>
                                <pre>public&nbsp;&lt;T extends <a
                                        href="../../../../org/apache/poi/ddf/EscherProperty.html"
                                        title="class in org.apache.poi.ddf">EscherProperty</a>&gt;&nbsp;T&nbsp;lookup(int&nbsp;propId)</pre>
                            </li>
                        </ul>
                        <a name="serialize-int-byte:A-org.apache.poi.ddf.EscherSerializationListener-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>serialize</h4>
                                <pre>public&nbsp;int&nbsp;serialize(int&nbsp;offset,
                     byte[]&nbsp;data,
                     <a href="../../../../org/apache/poi/ddf/EscherSerializationListener.html"
                        title="interface in org.apache.poi.ddf">EscherSerializationListener</a>&nbsp;listener)</pre>
                                <div class="block"><span
                                        class="descfrmTypeLabel">Description copied from class:&nbsp;<code><a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html#serialize-int-byte:A-org.apache.poi.ddf.EscherSerializationListener-">EscherRecord</a></code></span>
                                </div>
                                <div class="block">Serializes the record to an existing byte array.</div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../org/apache/poi/ddf/EscherRecord.html#serialize-int-byte:A-org.apache.poi.ddf.EscherSerializationListener-">serialize</a></code>&nbsp;in
                                        class&nbsp;<code><a href="../../../../org/apache/poi/ddf/EscherRecord.html"
                                                            title="class in org.apache.poi.ddf">EscherRecord</a></code>
                                    </dd>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>offset</code> - the offset within the byte array</dd>
                                    <dd><code>data</code> - the data array to serialize to</dd>
                                    <dd><code>listener</code> - a listener for begin and end serialization events. This
                                        is useful because the serialization is
                                        hierarchical/recursive and sometimes you need to be able
                                        break into that.
                                    </dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the number of bytes written.</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="sortProperties--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>sortProperties</h4>
                                <pre>public&nbsp;void&nbsp;sortProperties()</pre>
                                <div class="block">Records should be sorted by property number before being stored.
                                </div>
                            </li>
                        </ul>
                        <a name="setEscherProperty-org.apache.poi.ddf.EscherProperty-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>setEscherProperty</h4>
                                <pre>public&nbsp;void&nbsp;setEscherProperty(<a
                                        href="../../../../org/apache/poi/ddf/EscherProperty.html"
                                        title="class in org.apache.poi.ddf">EscherProperty</a>&nbsp;value)</pre>
                                <div class="block">Set an escher property. If a property with given propId already
                                    exists it is replaced.
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>value</code> - the property to set.</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="removeEscherProperty-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>removeEscherProperty</h4>
                                <pre>public&nbsp;void&nbsp;removeEscherProperty(int&nbsp;num)</pre>
                            </li>
                        </ul>
                        <a name="getAttributeMap--">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>getAttributeMap</h4>
                                <pre>protected&nbsp;java.lang.Object[][]&nbsp;getAttributeMap()</pre>
                                <div class="block"><span
                                        class="descfrmTypeLabel">Description copied from class:&nbsp;<code><a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html#getAttributeMap--">EscherRecord</a></code></span>
                                </div>
                                <div class="block">For the purpose of providing toString() and toXml() a subclass can
                                    either override those methods
                                    or provide a Object[][] array in the form <code>{ { "Attribute Name (Header)",
                                        value, "optional attribute", value }, ... } </code>.<p>

                                        Null values won't be printed.
                                    <p>

                                        The attributes record, version, instance, options must not be returned.</div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../org/apache/poi/ddf/EscherRecord.html#getAttributeMap--">getAttributeMap</a></code>&nbsp;in
                                        class&nbsp;<code><a href="../../../../org/apache/poi/ddf/EscherRecord.html"
                                                            title="class in org.apache.poi.ddf">EscherRecord</a></code>
                                    </dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the attribute map</dd>
                                </dl>
                            </li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.bottom.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/AbstractEscherOptRecord.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../index-all.html">Index</a></li>
        <li><a href="../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li>Prev&nbsp;Class</li>
        <li><a href="../../../../org/apache/poi/ddf/DefaultEscherRecordFactory.html"
               title="class in org.apache.poi.ddf"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../index.html?org/apache/poi/ddf/AbstractEscherOptRecord.html" target="_top">Frames</a>
        </li>
        <li><a href="AbstractEscherOptRecord.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_bottom">
        <li><a href="../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.bottom">
        <!--   -->
    </a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy">
    <small>
        <i>Copyright 2018 The Apache Software Foundation or
            its licensors, as applicable.</i>
    </small>
</p>
</body>
</html>
